;
;       CMP functions library v1.00
;       (CMP=Compare Based Compression)
;
;       Extracts the CMP algorythm packed data(Very simple one).
;
;      ----------------------------------------------------------
;      | Function name  |       Owner           |   Registers   |
;      ----------------------------------------------------------
;      | extract_cmp    | User                  | r0=Source     |
;      |                |                       | r1=Length     |
;      |                |                       | r2=Output     |
;      |                |                       |               |
;      |                |                       |               |
;      |                |                       |               |
;      ----------------------------------------------------------
;

extract_cmp             lda r0
                        ldx r0+1
                        sta $30
                        stx $31
                        lda r1
                        ldx r1+1
                        sta $32
                        stx $33
                        lda r2
                        ldx r2+1
                        sta $34
                        stx $35
                        ldy #0
extract_cmp_l1          lda $32
                        bne extract_cmp_nz
                        lda $33
                        bne extract_cmp_nz
                        rts
extract_cmp_nz          lda ($30),y
                        cmp #$54
                        bne extract_cmp_l2
                        iny
                        lda ($30),y
                        pha
                        clc
                        adc $34
                        sta $34
                        lda $35
                        adc #0
                        sta $35
                        pla
                        clc
                        adc $32
                        sta $32
                        lda $33
                        adc #0
                        sta $33
                        dey
                        lda $30
                        clc
                        adc #2
                        sta $30
                        lda $31
                        adc #0
                        sta $31
                        jmp extract_cmp_l1
extract_cmp_l2          sta ($34),y
                        inc $34
                        bne extract_cmp_l3
                        inc $35
extract_cmp_l3          inc $32
                        bne extract_cmp_l4
                        inc $33
extract_cmp_l4          jmp extract_cmp_l1

