;
;               VIC graphics library, C-64 version.
;       (C)1998 by Jari Tapio Tuominen, all rights reserved.
;
; (Only very limited amount of functions,
;  however you can include other libraries with more functions to
;  prove better performance.)
;
; (Name)                (Belongs to)            (ECPU registers)
; graphmode             User                    None
; textmode              User                    None
; putpixel              User                    r0=x, r1=y and r2=color.
; waitsd                User                    None(Wait screen redraw)
; movemem               User                    r0=Source,r1=Length,r2=Destination
; cpaint                User                    r0=$0400-$07e8 fill byte
; cpaint2               User                    r0=$d800-$dbe8 fill byte
; 
;

bitmapadr = $2000

movemem         lda r0
                ldx r0+1
                sta $30
                stx $31
                lda r1
                ldx r1+1
                sta $32
                stx $33
                lda r2
                ldx r2+1
                sta $34
                stx $35
                ldy #0
movemem_l1      lda ($30),y
                sta ($34),y
                inc $30
                bne movemem_i30
                inc $31
movemem_i30     inc $34
                bne movemem_i34
                inc $35
movemem_i34     lda $32
                sec
                sbc #1
                sta $32
                lda $33
                sbc #0
                sta $33
                bne movemem_l1
                rts

;Set graphics mode
graphmode       lda #$3b                ; Setup bitmap mode
                sta $d011
                jsr screenoff           ; But turn it off right away for setup
                jsr waitsd
                lda #$10
                sta r0
                jsr cpaint
                lda #$19
                sta $d018
                jsr hiresmode
                lda $dd00
                ora #3
                sta $dd00
                lda #0
                sta $d015
                sta $d020
                sta $d021
                sta $d030
                jsr waitsd              ; Wait for screen redraw,
                jsr screenon            ; Bang we're on bitmap !
                rts

cpaint          ldx #0
                lda r0
graphmodeloop1  sta $0400,x
                sta $0500,x
                sta $0600,x
                sta $0700,x
                inx
                bne graphmodeloop1
                rts

cpaint2         ldx #0
                lda r0
graphmodeloop2  sta $d800,x
                sta $d900,x
                sta $da00,x
                sta $db00,x
                inx
                bne graphmodeloop2
                rts

;Clear bitmap
clearbitmap     lda #$00
                ldx #$20
                sta $30
                stx $31
                ldy #0
                tya
clearbitmapl1   sta ($30),y
                iny
                bne clearbitmapl1
                inc $31
                ldx $31
                cpx #$40
                bne clearbitmapl1
                rts

;Set text mode
textmode        jmp $ff81

;r0,r1,r2 .. r0=x r1=y r2=color
putpixel        lda r2
                beq nocolor
                lda r1
                lsr
                lsr
                lsr
                tax
                lda r0
                and #$f8
                clc
                adc plo,x
                sta $30
                lda phi,x
                adc r0+1
                sta $31
                lda r0
                and #7
                tax
                lda r1
                and #7
                tay
                lda ($30),y
                ora bits,x
                sta ($30),y
                rts
                ;
nocolor         lda r1
                lsr
                lsr
                lsr
                tax
                lda r0
                and #$f8
                clc
                adc plo,x
                sta $30
                lda phi,x
                adc r0+1
                sta $31
                lda r0
                and #7
                tax
                lda r1
                and #7
                tay
                lda ($30),y
                and abits,x
                sta ($30),y
                rts
bits            .byte 128,64,32,16,8,4,2,1
abits           .byte 255-128,255-64,255-32,255-16,255-8,255-4,255-2,255-1
plo             .byte <(bitmapadr+($00*320))
                .byte <(bitmapadr+($01*320))
                .byte <(bitmapadr+($02*320))
                .byte <(bitmapadr+($03*320))
                .byte <(bitmapadr+($04*320))
                .byte <(bitmapadr+($05*320))
                .byte <(bitmapadr+($06*320))
                .byte <(bitmapadr+($07*320))
                .byte <(bitmapadr+($08*320))
                .byte <(bitmapadr+($09*320))
                .byte <(bitmapadr+($0a*320))
                .byte <(bitmapadr+($0b*320))
                .byte <(bitmapadr+($0c*320))
                .byte <(bitmapadr+($0d*320))
                .byte <(bitmapadr+($0e*320))
                .byte <(bitmapadr+($0f*320))
                .byte <(bitmapadr+($10*320))
                .byte <(bitmapadr+($11*320))
                .byte <(bitmapadr+($12*320))
                .byte <(bitmapadr+($13*320))
                .byte <(bitmapadr+($14*320))
                .byte <(bitmapadr+($15*320))
                .byte <(bitmapadr+($16*320))
                .byte <(bitmapadr+($17*320))
                .byte <(bitmapadr+($18*320))
                ;
phi             .byte >(bitmapadr+($00*320))
                .byte >(bitmapadr+($01*320))
                .byte >(bitmapadr+($02*320))
                .byte >(bitmapadr+($03*320))
                .byte >(bitmapadr+($04*320))
                .byte >(bitmapadr+($05*320))
                .byte >(bitmapadr+($06*320))
                .byte >(bitmapadr+($07*320))
                .byte >(bitmapadr+($08*320))
                .byte >(bitmapadr+($09*320))
                .byte >(bitmapadr+($0a*320))
                .byte >(bitmapadr+($0b*320))
                .byte >(bitmapadr+($0c*320))
                .byte >(bitmapadr+($0d*320))
                .byte >(bitmapadr+($0e*320))
                .byte >(bitmapadr+($0f*320))
                .byte >(bitmapadr+($10*320))
                .byte >(bitmapadr+($11*320))
                .byte >(bitmapadr+($12*320))
                .byte >(bitmapadr+($13*320))
                .byte >(bitmapadr+($14*320))
                .byte >(bitmapadr+($15*320))
                .byte >(bitmapadr+($16*320))
                .byte >(bitmapadr+($17*320))
                .byte >(bitmapadr+($18*320))
                ;
waitsd          lda #$ff
waitsdl         cmp $d012
                bne waitsdl
                lda $d012
waitsdl2        cmp $d012
                beq waitsdl2
                rts

textbackground  lda r0
                sta $d021
                rts

textborder      lda r0
                sta $d020
                rts

textcolor       lda r0
                sta 646
                rts

multicolor      lda #$d8
                sta $d016
                rts

hiresmode       lda #$c8
                sta $d016
                rts

screenoff       lda $d011
                and #$ef
                sta $d011
                rts

screenon        lda $d011
                ora #$10
                sta $d011
                rts

waitsec         ldy r0
waitsecl2       ldx #50
waitsecl        jsr waitsd
                dex
                bne waitsecl
                dey
                bne waitsecl2
                rts

;Unique created ASM file
;Compile date: Mon Aug 31 13:40:58 1998

;For processor: 386.

fillbox nop

           lda r1
           sta r5
           lda r1+1
           sta r5+1

           lda r0
           sta r4
           lda r0+1
           sta r4+1
fillbox_l2 nop

fillbox_l1      lda #<255
                ldx #>255
                sta r2+0
                stx r2+1
                jsr putpixel ;Calls subroutine 'putpixel'

                lda r0+0
                cmp r2+0
                bne fillbox_ll1
                lda r0+1
                cmp r2+1
                beq fillbox_le1
                ;
fillbox_ll1  lda r0
clc
adc #<1
sta r0
lda r0+1
adc #>1
sta r0+1
jmp fillbox_l1
fillbox_le1 lda r4
           sta r0
           lda r4+1
           sta r0+1
lda r2+0
cmp r3+0
bne fillbox_ll2
lda r2+1
cmp r3+1
beq fillbox_le2

fillbox_ll2 lda r1
clc
adc #<1
sta r1
lda r1+1
adc #>1
sta r1+1

jmp fillbox_l2

fillbox_le2 lda r5
sta r1
lda r5+1
sta r1+1
rts ;Return from subroutine

fillbox_x .byte 0

fillbox_y .byte 0
.byte 0
;** END :) **





;Unique created ASM file
;Compile date: Mon Aug 31 14:23:59 1998

;For processor: 386.

drawbox lda r0
ldx r0+1
sta drawbox_x1
stx drawbox_x1+1
lda r1
ldx r1+1
sta drawbox_y1
stx drawbox_y1+1
lda r2
ldx r2+1
sta drawbox_x2
stx drawbox_x2+1
lda r3
ldx r3+1
sta drawbox_y2
stx drawbox_y2+1
lda drawbox_x1+0
ldx drawbox_x1+1
sta r0+0
stx r0+1
lda drawbox_y1+0
ldx drawbox_y1+1
sta r1+0
stx r1+1
lda drawbox_x2+0
ldx drawbox_x2+1
sta r2+0
stx r2+1
lda drawbox_y1+0
ldx drawbox_y1+1
sta r3+0
stx r3+1
jsr fillbox ;Calls subroutine 'fillbox'
lda drawbox_x2+0
ldx drawbox_x2+1
sta r0+0
stx r0+1
lda drawbox_y1+0
ldx drawbox_y1+1
sta r1+0
stx r1+1
lda drawbox_x2+0
ldx drawbox_x2+1
sta r2+0
stx r2+1
lda drawbox_y2+0
ldx drawbox_y2+1
sta r3+0
stx r3+1
jsr fillbox ;Calls subroutine 'fillbox'
lda drawbox_x1+0
ldx drawbox_x1+1
sta r0+0
stx r0+1
lda drawbox_y2+0
ldx drawbox_y2+1
sta r1+0
stx r1+1
lda drawbox_x2+0
ldx drawbox_x2+1
sta r2+0
stx r2+1
lda drawbox_y2+0
ldx drawbox_y2+1
sta r3+0
stx r3+1
jsr fillbox ;Calls subroutine 'fillbox'
lda drawbox_x1+0
ldx drawbox_x1+1
sta r0+0
stx r0+1
lda drawbox_y1+0
ldx drawbox_y1+1
sta r1+0
stx r1+1
lda drawbox_x1+0
ldx drawbox_x1+1
sta r2+0
stx r2+1
lda drawbox_y2+0
ldx drawbox_y2+1
sta r3+0
stx r3+1
jsr fillbox ;Calls subroutine 'fillbox'
rts ;Return from subroutine
drawbox_x1 .word 0
drawbox_y1 .word 0
drawbox_x2 .word 0
drawbox_y2 .word 0
;** END :) **

ansiclrscr      jmp $e544
