;--------------------------------------------------------------------------
;
; MATH.ASM
; --------
;
; Very simple mathematical functions like: mulw,divw,
;                                          addw,setw,subw.
;
; Divide and other complexity functions are still unfinished, coming soon.
; 
;--------------------------------------------------------------------------
;(Function name)        (Working)
;mulw                   r2=r0*r1
;divw                   r2=r0/r1(Coming soon)
;addw                   r2=r0+r1
;subw                   r2=r0-r1
;setw                   (r0)=(r1)
;
; Explains:
; ---------
;
; (..) = Offset
; .... = Uses registers, f.e. addw returns answer in r2.
;
;--------------------------------------------------------------------------

;r0*r1, result in r2
mulw        lda #0
            sta $30
            sta $31
            lda r1
            ldx r1+1
            sta $32
            stx $33
            lda r0
            ldx r0+1
            sta $34
            stx $35
            ;Calculating loop
mulwl1      lda $34
            bne mulwlz
            lda $35
            bne mulwlz
            beq mulwl2
mulwlz      lda $30
            clc
            adc $32
            sta $30
            lda $31
            adc $33
            sta $31
            lda $34
            sec
            sbc #1
            sta $34
            lda $35
            sbc #0
            sta $35
            jmp mulwl1
            ;-------------
mulwl2      lda $30
            ldx $31
            sta r2+0
            stx r2+1
            rts
;--------------------------------------------------------------------------
;r0/r1, result in r2
divw        rts    
;--------------------------------------------------------------------------
;r0+r1, result in r2
addw        lda r0
            clc
            adc r1
            sta r2
            lda r0+1
            adc r1+1
            sta r2+1
            rts
;--------------------------------------------------------------------------
;r0-r1, result in r2
subw        lda r0
            sec
            sbc r1
            sta r2
            lda r0+1
            sbc r1+1
            sta r2+1
            rts
;--------------------------------------------------------------------------
;r0+1, result in r2.
incw        lda r2
            clc
            adc #1
            sta r2
            lda r0+1
            adc #0
            sta r2+1
            rts
;--------------------------------------------------------------------------
;r0-1, result in r2
decw        lda r0
            sec
            sbc #1
            sta r2
            lda r0+1
            sbc #0
            sta r2+1
            rts
;--------------------------------------------------------------------------
;(r0)=(r1), example call: setb( var1& var2& );
setb        lda $30
            pha
            lda $31
            pha
            lda $32
            pha
            lda $33
            pha
            lda r1
            ldx r1+1
            sta $30
            stx $31
            lda r0
            ldx r0+1
            sta $32
            stx $33
            ldy #0
            lda ($30),y
            sta ($32),y
            pla
            sta $33
            pla
            sta $32
            pla
            sta $31
            pla
            sta $30
            rts
;--------------------------------------------------------------------------
;(r0)=(r1), example call: setw( var1& var2& );
setw        lda $30
            pha
            lda $31
            pha
            lda $32
            pha
            lda $33
            pha
            lda r1
            ldx r1+1
            sta $30
            stx $31
            lda r0
            ldx r0+1
            sta $32
            stx $33
            ldy #0
            lda ($30),y
            sta ($32),y
            iny
            lda ($30),y
            sta ($32),y
            pla
            sta $33
            pla
            sta $32
            pla
            sta $31
            pla
            sta $30
            rts
;--------------------------------------------------------------------------
;(r0)=(r1), example call: setwo( offsetvar1& var2& );
;
; Notice: Does as setwo expect var1 well be (var1) instead of var1,
;         so it the source parameter(first one) is an address to
;         the real source parameter.
;
setwo       lda $30
            pha
            lda $31
            pha
            lda $32
            pha
            lda $33
            pha
            lda r1
            ldx r1+1
            sta $30
            stx $31
            lda r0
            ldx r0+1
            sta $32
            stx $33
            ;
            ldy #0
            lda ($30),y
            pha
            iny
            lda ($30),y
            sta $31
            pla
            sta $30
            ;
            ldy #0
            lda ($30),y
            sta ($32),y
            iny
            lda ($30),y
            sta ($32),y
            pla
            sta $33
            pla
            sta $32
            pla
            sta $31
            pla
            sta $30
            rts
;--------------------------------------------------------------------------
;(r0)=(r1), example call: setbo( offsetvar1& var2& );
;
; Notice: Does as setb expect var1 well be (var1) instead of var1,
;         so it the source parameter(first one) is an address to
;         the real source parameter.
;
setbo       lda $30
            pha
            lda $31
            pha
            lda $32
            pha
            lda $33
            pha
            lda r1
            ldx r1+1
            sta $30
            stx $31
            lda r0
            ldx r0+1
            sta $32
            stx $33
            ;
            ldy #0
            lda ($30),y
            pha
            iny
            lda ($30),y
            sta $31
            pla
            sta $30
            ;
            ldy #0
            lda ($30),y
            sta ($32),y
            pla
            sta $33
            pla
            sta $32
            pla
            sta $31
            pla
            sta $30
            rts
;--------------------------------------------------------------------------
