;----------------------------------------------------------------------------
;
;       Conventional Memory RAMDISK for JTT language, version 1.00.
;       (C)1998 by Jari Tapio Tuominen, all rights reserved.
;
;       Description:
;       +You may use Ramdisk for storing files at Memory,
;        ramdisk makes it easy.
;       +Ramdisk won't allocate more memory than current
;        directory structure and files takes space.
;       +Ramdisk uses Dynamic Memory Allocation,
;        which makes possible to use Ramdisk with
;        other application in same memory..
;        However it requires that other applications in
;        same memory uses same Memory Server.
;----------------------------------------------------------------------------
;RAMDALLOC
;This function allocates memory for Ramdisk directory system.
;
ramdalloc       lda #4
                jsr malloc
                sta ramdisk     ; Save directory structure key and offset.
                stx ramdisk+1   
                rts
;----------------------------------------------------------------------------
ramdformat      jsr ramdalloc
                lda #1
                ldx #<ramd_fnroot
                jsr ramdcreat
                jsr ramdg30ramdisk
                ldy #0
                tya
                sta ($30),y
                rts
;----------------------------------------------------------------------------
;RAMDG30RAMDISK
;Stores (malloc*)Ramdisk offset into <<$30,$31>>
;
ramdg30ramdisk  lda #0
                ldx ramdisk+1
                sta $30
                stx $31
                rts
;----------------------------------------------------------------------------
;RAMDG30SEARCHEP
;Search for next empty position in the ramdisk.
;
ramdsfornep     ldy #0
;----------------------------------------------------------------------------
;RAMDCREAT
;This function creates new file into Ramdisk directory structure.
;
ramdcreat       pha
                txa
                pha
                tya
                pha
                ;
                jsr ramdg30ramdisk
                jsr ramdsfornep
                pla
                ldy #0
                sta ($30),y
                ;
                rts
;----------------------------------------------------------------------------
ramd_fnroot     .text "..\"
                .byte 0
;----------------------------------------------------------------------------
ramdisk         .byte 0 ;;;; Ramdisk key
                .byte 0 ;;;; Offset to ramdisk 
;----------------------------------------------------------------------------

;----------------------------------------------------------------------------
