;
;               1x1 scroll library 
;
;               (C)1998 by Jari Tapio Tuominen, all rights reserved.
;
;               ---------------
;               |  MC BITMAP  |
;               |  PICTURE    | <-- Picture = 320x196 (MC)
;               |             | 
;               |   Scroller  | <-- Scroller = 320x8 (Hires ROM font)
;               ---------------
;

scroll1_on      lda r0
                ldx r0+1
                sta scroll1_texto
                stx scroll1_texto+1
                ;
                jsr scroll1_init1x1
                jsr scroll1_setirq
                lda #$8a
                sta r0
                jsr cpaint
                lda #$0f
                sta r0
                jsr cpaint2
                lda $dd00
                ora #3
                sta $dd00
                ldx #0
scroll1_loop1   lda #$20
                sta $07c0,x
                lda #1
                sta $dbc0,x
                inx
                cpx #$28
                bne scroll1_loop1
                jsr waitsd
                lda #$3b
                sta $d011
                rts

scroll1_setirq  sei
                lda #<scroll1_irq
                ldx #>scroll1_irq
                sta $0314
                stx $0315
                lda #1
                sta $d01a
                sta $dc0d
                lda $d011
                and #$7f
                sta $d011
                lda #0
                sta $d012
                cli
                rts

scroll1_irq     lda #$3b
                sta $d011
                lda #$19
                sta $d018
                lda #$d8
                sta $d016
                lda #0
                sta $d020
                lda #9
                sta $d021
                ;
                jsr playifavailable
                ;
                jsr scroll1_s1x1
                ;
                lda #$30+(24*8)
                ldx #<scroll1_irq2
                ldy #>scroll1_irq2
                jmp scroll1_si
                ;-------------------------
scroll1_irq2    lda #$31+(24*8)
scroll1_loop2   cmp $d012
                bne scroll1_loop2
                ldx #8
scroll1_loop3   lda ($30),y
                dex
                bne scroll1_loop3
                lda ($30),y
                lda ($30),y
                lda ($30),y
                nop
                nop
                nop
                lda #$16
                sta $d018
                lda scroll1_d016
                sta $d016
                lda #$1b
                sta $d011
                lda #0
                sta $d021
                ;
                lda #$00
                ldx #<scroll1_irq
                ldy #>scroll1_irq
                jmp scroll1_si

scroll1_si      sta $d012
                stx $0314
                sty $0315
                inc $d019
                jmp $ea7e

scroll1_d016    .byte 7

scroll1_s1x1    nop
                dec scroll1_d016
                lda scroll1_d016
                cmp #$ff
                beq scroll1_iff
                rts
scroll1_iff     lda #7
                sta scroll1_d016
                ldx #0
scroll1_s1x1_l1 lda $07c1,x
                sta $07c0,x
                inx
                cpx #$27
                bne scroll1_s1x1_l1
                ldy #0
scroll1_ag      lda ($30),y
                cmp #0
                bne scroll1_nz
                jsr scroll1_init1x1
                jmp scroll1_ag
scroll1_nz      sta $07e7
                jsr scroll1_i30
                rts

scroll1_i30     inc $30
                bne scroll1_b30
                inc $31
scroll1_b30     rts

scroll1_init1x1 lda scroll1_texto
                ldx scroll1_texto+1
                sta $30
                stx $31
                rts

scroll1_texto   .word 0
