;----------------------------------------------------------------------------
;       Windows Graphics Library
;       (C)1998 by Jari Tapio Tuominen, all rights reserved.
;
;       Requires GRAPH.ASM library.
;
;----------------------------------------------------------------------------


;----------------------------------------------------------------------------
;       DRAWBLOCK
;       ---------
;
;       Arguments: R0,R1 = X,Y
;
;       Description:
;
;       Function draws 8x8 block at coordinate point(r0,r1)
;       Coordinates are normal 320x200 based coordinates,
;       so treat these as 320x200 coordinates.
;       Both coordinates, x,y are 16bit, so remember to treat these as 16bit!
;       To use X,Y as 8bit coordinates you must first put NULL at both
;       R0,R1 VCPU registers.
;----------------------------------------------------------------------------
drawblock               lda r1
                        lsr
                        lsr
                        lsr
                        tax
                        lda r0
                        and #$f8
                        clc
                        adc plo,x
                        sta $30
                        lda phi,x
                        adc r0+1
                        sta $31
                        ldy #7
                        lda r2
drawblock_l1            sta ($30),y
                        dey
                        bpl drawblock_l1
                        rts

;----------------------------------------------------------------------------
;       DRAWBLOCKS
;       ----------
;
;       Arguments: R0,R1-R2,R3 by R4 = X1,Y1-X2,Y2
;
;       Description :
;
;       This function draws specified rectangle area with
;       eight bit, four color data information.
;       Fifth argument is ofcourse fill BYTE which contains eight bits,
;       and four colors or either eight monochrome colors*.
;
;       * Requires monochrome 320x200 graphic mode.
;
;----------------------------------------------------------------------------
drawblocks              nop
                        ;
drawblocks_l2           lda r0
                        pha
                        lda r0+1
                        pha                                
drawblocks_l1           lda r2
                        pha
                        lda r4
                        sta r2
                        jsr drawblock
                        pla
                        sta r2
                        lda r0
                        clc
                        adc #8
                        sta r0
                        lda r0+1
                        adc #0
                        sta r0+1
                        lda r0
                        cmp r2
                        bcc drawblocks_l1
                        lda r0+1
                        cmp r2+1
                        bcc drawblocks_l1
                        pla
                        sta r0+1
                        pla
                        sta r0
                        lda r1
                        clc
                        adc #8
                        sta r1
                        lda r1+1
                        adc #0
                        sta r1+1
                        lda r1
                        cmp r3
                        bcc drawblocks_l2
                        lda r1+1
                        cmp r3+1
                        bcc drawblocks_l2
                        ;
                        rts
