;Unique created ASM file
;Compile date: Fri Apr 30 00:30:59 1999

;For processor: 386.
*=$1000
                jmp main ;BEGIN
;*********************** >>CPU.ASM<< ************************
;
; Emulated CPU layout
;
; (16 bit registers)
;  r0
;  r1
;  r2
;  r3
;  r4
;  r5
;  r6
;  r7
;

;16bit registers, every register contains two 16bit sides.
r0 .word 0,0
r1 .word 0,0
r2 .word 0,0
r3 .word 0,0
r4 .word 0,0
r5 .word 0,0
r6 .word 0,0
r7 .word 0,0

;
; DOC:
; ----
;
; function( arg1, arg2, arg3, arg4 )
;
; ldx arg1+0
; ldy arg1+1
; stx r0+0
; sty r0+1
;
; ldx arg2+0
; ldy arg2+1
; stx r1+0
; sty r1+1
;
; ldx arg3+0
; ldy arg3+1
; stx r2+0
; sty r2+1
;
; ldx arg4+0
; ldy arg4+1
; stx r3+0
; sty r3+1
;
;
;
;
;

;
;       asmcall( asmfunction rega regx regy );
;
asmcall         lda r1
                ldx r2
                ldy r3
                jmp (r0)

;
;       setregs( rega regx regy );
;
setregs         lda r0
                ldx r1
                ldy r2
                rts
;************************************************************
;
;
; ILOAD & Execute 
;
; This routine loads executable file using Dow Jones irq-loader,
; after loading it setups safemode interrupt and checks if
; the loaded code is "GOOD" code, if it is then it
; executes the code which is possible to execute, and which is fully legal.
;

iexecute_hz50   lda #$ff
iexecute_hz50_l1 cmp $d012
                bne iexecute_hz50_l1
                rts

iexecute        jsr iexecute_hz50
                ldx #$2f
iexecute_l1     lda iexecute_ih02a7,x
                sta $02a7,x
                lda iexecute_lc0334,x
                sta $0334,x
                dex
                bpl iexecute_l1
                                  ; Irq handler at $02a7 (JTT stylish)
                sei               ; LDR caller at $0334
                lda #<$02a7
                ldx #>$02a7
                sta $0314
                stx $0315
                lda #1
                sta $d01a
                sta $dc0d
                lda $d011
                and #$7f
                sta $d011
                lda #0
                sta $d012
                cli
                jmp $0334

iexecute_lc0334 jsr $c000
                lda $0800
                sta $30
                lda $0801
                sta $31
                ldy #0
                lda ($30),y             ; JMP opcode must be included in 
                cmp #$4c                ; beginning of every legal
                bne iexecute_sererr     ; Unique / JTT system executable file.
                jmp ($0800)
iexecute_sererr sei
                lda #$37
                sta 1
                jmp ($fffc)

iexecute_ih02a7 lda $1003
                cmp #$4c ; JMP opcode at address $1003 ? Yes = Play music/What ever
                bne iexecute_nplay
                jsr $1003
iexecute_nplay  nop
                inc $d019
                jmp $ea7e

iexecute_load   lda r0
                ldx r0+1
                sta $30
                stx $31
                ldy #0
                lda ($30),y
                tax
                iny
                lda ($30),y
                tay
                jmp $c200

playifavailable lda $1003
                cmp #$4c
                bne playifavailablel
                jsr $1003
playifavailablel rts

initmusic       lda #0
                tax
                tay
                jmp $1000

nosound         ldx #0
                txa
nosoundl1       sta $d400,x
                inx
                cpx #$19
                bne nosoundl1
                rts
ibmpview                lda #$0b
;
;       MB/IBMP viewer library (MultiBackground Color enchanced)
;
;       $0400-$07e8 -> Screen, program copy $0400-$07e8
;                      to $4400 automatically.
;       $d800-$dbe8 -> Colors.
;       $0f00-$0fc8 -> One $d021 for each line(y).
;
;
;       Bug found and fixed :
;
;               $dd00 should be changed by changing
;               only two first bits, the video bank specifier.
;
                        sta $d011
                        ;
                        lda #0
                        sta $d020
                        sta $d021
                        ldx #0
loop                    lda $0400,x
                        sta $4400,x
                        lda $0500,x
                        sta $4500,x
                        lda $0600,x
                        sta $4600,x
                        lda $0700,x
                        sta $4700,x
                        inx
                        bne loop
                        ;
                        sei
                        lda #<ibmpirq
                        ldx #>ibmpirq
                        sta $0314
                        stx $0315
                        lda #1
                        sta $d01a
                        sta $dc0d
                        lda #$3b
                        sta $d011
                        lda #$00
                        sta $d012
                        lda #0
                        sta ibmpcounter
                        sta ibmpcounter+1
                        sta ibmpcounter+2
                        sta ibmpcounter+3
                        cli
                        ;
                        rts

ibmpiupdate             nop
                        ;
ibmpdd00                lda #3
                        eor #1
                        sta ibmpora+1
                        lda $dd00
                        and #%11111100
ibmpora                 ora #0
                        sta $dd00
                        sta ibmpdd00+1
                        ;
ibmpd016                lda #$d8
                        eor #1
                        sta ibmpd016+1
                        sta $d016
                        ;
ibmpd018                lda #$19
                        sta $d018
                        ;
                        rts

ibmpilace               .byte $ff

ibmpirq                 lda ibmpilace
                        beq ibmpirql1
                        jsr ibmpiupdate
ibmpirql1               lda ibmpflash
                        beq ibmpirql2
                        jsr ibmpflashing
ibmpirql2               nop
                        jsr ibmptimer
;                        jsr playifavailable
                        ;
                        ; Produce multi-background colors with a rasterbar.
                        ;
                        lda #$33
                        sta ibmpirql4+1
                        ;
                        ldx #$00
ibmpirql4               lda #$33
                        ldy $0f00,x
ibmpirql5               cmp $d012
                        bne ibmpirql5
                        sty $d021
                        inc ibmpirql4+1
                        inx
                        cpx #200
                        bne ibmpirql4
                        ;
                        inc $d019
                        jmp $ea7e

ibmpcounter             .word 0,0

ibmptimer               lda ibmpcounter+0
                        clc
                        adc #1
                        sta ibmpcounter+0
                        lda ibmpcounter+1
                        adc #0
                        sta ibmpcounter+1
                        lda ibmpcounter+2
                        adc #0
                        sta ibmpcounter+2
                        lda ibmpcounter+3
                        adc #0
                        sta ibmpcounter+3
                        rts

ibmpflashing            lda ibmpcounter+0
                        lsr
                        lsr
                        lsr
                        lsr
                        and #31
                        tax
                        lda cols,x
                        sta $d020
                        rts
cols                    .byte $00,$09,$08,$0a
                        .byte $0f,$0a,$08,$09
                        .byte $00,$06,$0e,$03
                        .byte $0d,$03,$0e,$06
                        .byte $00,$0b,$0c,$0f
                        .byte $07,$0f,$0c,$0b
                        .byte $00,$06,$04,$0e
                        .byte $03,$0e,$04,$06

ibmpflash               .byte 0
;
;               VIC graphics library, C-64 version.
;       (C)1998 by Jari Tapio Tuominen, all rights reserved.
;
; (Only very limited amount of functions,
;  however you can include other libraries with more functions to
;  prove better performance.)
;
; (Name)                (Belongs to)            (ECPU registers)
; graphmode             User                    None
; textmode              User                    None
; putpixel              User                    r0=x, r1=y and r2=color.
; waitsd                User                    None(Wait screen redraw)
; movemem               User                    r0=Source,r1=Length,r2=Destination
; cpaint                User                    r0=$0400-$07e8 fill byte
; cpaint2               User                    r0=$d800-$dbe8 fill byte
; 
;

bitmapadr = $2000

movemem         lda r0
                ldx r0+1
                sta $30
                stx $31
                lda r1
                ldx r1+1
                sta $32
                stx $33
                lda r2
                ldx r2+1
                sta $34
                stx $35
                ldy #0
movemem_l1      lda ($30),y
                sta ($34),y
                inc $30
                bne movemem_i30
                inc $31
movemem_i30     inc $34
                bne movemem_i34
                inc $35
movemem_i34     lda $32
                sec
                sbc #1
                sta $32
                lda $33
                sbc #0
                sta $33
                bne movemem_l1
                rts

;Set graphics mode
graphmode       lda #$3b                ; Setup bitmap mode
                sta $d011
                jsr screenoff           ; But turn it off right away for setup
                jsr waitsd
                lda #$10
                sta r0
                jsr cpaint
                lda #$19
                sta $d018
                jsr hiresmode
                lda $dd00
                ora #3
                sta $dd00
                lda #0
                sta $d015
                sta $d020
                sta $d021
                sta $d030
                jsr waitsd              ; Wait for screen redraw,
                jsr screenon            ; Bang we're on bitmap !
                rts

cpaint          ldx #0
                lda r0
graphmodeloop1  sta $0400,x
                sta $0500,x
                sta $0600,x
                sta $0700,x
                inx
                bne graphmodeloop1
                rts

cpaint2         ldx #0
                lda r0
graphmodeloop2  sta $d800,x
                sta $d900,x
                sta $da00,x
                sta $db00,x
                inx
                bne graphmodeloop2
                rts

;Clear bitmap
clearbitmap     lda #$00
                ldx #$20
                sta $30
                stx $31
                ldy #0
                tya
clearbitmapl1   sta ($30),y
                iny
                bne clearbitmapl1
                inc $31
                ldx $31
                cpx #$40
                bne clearbitmapl1
                rts

;Set text mode
textmode        jmp $ff81

;r0,r1,r2 .. r0=x r1=y r2=color
putpixel        lda r2
                beq nocolor
                lda r1
                lsr
                lsr
                lsr
                tax
                lda r0
                and #$f8
                clc
                adc plo,x
                sta $30
                lda phi,x
                adc r0+1
                sta $31
                lda r0
                and #7
                tax
                lda r1
                and #7
                tay
                lda ($30),y
                ora bits,x
                sta ($30),y
                rts
                ;
nocolor         lda r1
                lsr
                lsr
                lsr
                tax
                lda r0
                and #$f8
                clc
                adc plo,x
                sta $30
                lda phi,x
                adc r0+1
                sta $31
                lda r0
                and #7
                tax
                lda r1
                and #7
                tay
                lda ($30),y
                and abits,x
                sta ($30),y
                rts
bits            .byte 128,64,32,16,8,4,2,1
abits           .byte 255-128,255-64,255-32,255-16,255-8,255-4,255-2,255-1
plo             .byte <(bitmapadr+($00*320))
                .byte <(bitmapadr+($01*320))
                .byte <(bitmapadr+($02*320))
                .byte <(bitmapadr+($03*320))
                .byte <(bitmapadr+($04*320))
                .byte <(bitmapadr+($05*320))
                .byte <(bitmapadr+($06*320))
                .byte <(bitmapadr+($07*320))
                .byte <(bitmapadr+($08*320))
                .byte <(bitmapadr+($09*320))
                .byte <(bitmapadr+($0a*320))
                .byte <(bitmapadr+($0b*320))
                .byte <(bitmapadr+($0c*320))
                .byte <(bitmapadr+($0d*320))
                .byte <(bitmapadr+($0e*320))
                .byte <(bitmapadr+($0f*320))
                .byte <(bitmapadr+($10*320))
                .byte <(bitmapadr+($11*320))
                .byte <(bitmapadr+($12*320))
                .byte <(bitmapadr+($13*320))
                .byte <(bitmapadr+($14*320))
                .byte <(bitmapadr+($15*320))
                .byte <(bitmapadr+($16*320))
                .byte <(bitmapadr+($17*320))
                .byte <(bitmapadr+($18*320))
                ;
phi             .byte >(bitmapadr+($00*320))
                .byte >(bitmapadr+($01*320))
                .byte >(bitmapadr+($02*320))
                .byte >(bitmapadr+($03*320))
                .byte >(bitmapadr+($04*320))
                .byte >(bitmapadr+($05*320))
                .byte >(bitmapadr+($06*320))
                .byte >(bitmapadr+($07*320))
                .byte >(bitmapadr+($08*320))
                .byte >(bitmapadr+($09*320))
                .byte >(bitmapadr+($0a*320))
                .byte >(bitmapadr+($0b*320))
                .byte >(bitmapadr+($0c*320))
                .byte >(bitmapadr+($0d*320))
                .byte >(bitmapadr+($0e*320))
                .byte >(bitmapadr+($0f*320))
                .byte >(bitmapadr+($10*320))
                .byte >(bitmapadr+($11*320))
                .byte >(bitmapadr+($12*320))
                .byte >(bitmapadr+($13*320))
                .byte >(bitmapadr+($14*320))
                .byte >(bitmapadr+($15*320))
                .byte >(bitmapadr+($16*320))
                .byte >(bitmapadr+($17*320))
                .byte >(bitmapadr+($18*320))
                ;
waitsd          lda #$ff
waitsdl         cmp $d012
                bne waitsdl
                lda $d012
waitsdl2        cmp $d012
                beq waitsdl2
                rts

textbackground  lda r0
                sta $d021
                rts

textborder      lda r0
                sta $d020
                rts

textcolor       lda r0
                sta 646
                rts

multicolor      lda #$d8
                sta $d016
                rts

hiresmode       lda #$c8
                sta $d016
                rts

screenoff       lda $d011
                and #$ef
                sta $d011
                rts

screenon        lda $d011
                ora #$10
                sta $d011
                rts

waitsec         ldy r0
waitsecl2       ldx #50
waitsecl        jsr waitsd
                dex
                bne waitsecl
                dey
                bne waitsecl2
                rts

;Unique created ASM file
;Compile date: Mon Aug 31 13:40:58 1998

;For processor: 386.

fillbox nop

           lda r1
           sta r5
           lda r1+1
           sta r5+1

           lda r0
           sta r4
           lda r0+1
           sta r4+1
fillbox_l2 nop

fillbox_l1      lda #<255
                ldx #>255
                sta r2+0
                stx r2+1
                jsr putpixel ;Calls subroutine 'putpixel'

                lda r0+0
                cmp r2+0
                bne fillbox_ll1
                lda r0+1
                cmp r2+1
                beq fillbox_le1
                ;
fillbox_ll1  lda r0
clc
adc #<1
sta r0
lda r0+1
adc #>1
sta r0+1
jmp fillbox_l1
fillbox_le1 lda r4
           sta r0
           lda r4+1
           sta r0+1
lda r2+0
cmp r3+0
bne fillbox_ll2
lda r2+1
cmp r3+1
beq fillbox_le2

fillbox_ll2 lda r1
clc
adc #<1
sta r1
lda r1+1
adc #>1
sta r1+1

jmp fillbox_l2

fillbox_le2 lda r5
sta r1
lda r5+1
sta r1+1
rts ;Return from subroutine

fillbox_x .byte 0

fillbox_y .byte 0
.byte 0
;** END :) **





;Unique created ASM file
;Compile date: Mon Aug 31 14:23:59 1998

;For processor: 386.

drawbox lda r0
ldx r0+1
sta drawbox_x1
stx drawbox_x1+1
lda r1
ldx r1+1
sta drawbox_y1
stx drawbox_y1+1
lda r2
ldx r2+1
sta drawbox_x2
stx drawbox_x2+1
lda r3
ldx r3+1
sta drawbox_y2
stx drawbox_y2+1
lda drawbox_x1+0
ldx drawbox_x1+1
sta r0+0
stx r0+1
lda drawbox_y1+0
ldx drawbox_y1+1
sta r1+0
stx r1+1
lda drawbox_x2+0
ldx drawbox_x2+1
sta r2+0
stx r2+1
lda drawbox_y1+0
ldx drawbox_y1+1
sta r3+0
stx r3+1
jsr fillbox ;Calls subroutine 'fillbox'
lda drawbox_x2+0
ldx drawbox_x2+1
sta r0+0
stx r0+1
lda drawbox_y1+0
ldx drawbox_y1+1
sta r1+0
stx r1+1
lda drawbox_x2+0
ldx drawbox_x2+1
sta r2+0
stx r2+1
lda drawbox_y2+0
ldx drawbox_y2+1
sta r3+0
stx r3+1
jsr fillbox ;Calls subroutine 'fillbox'
lda drawbox_x1+0
ldx drawbox_x1+1
sta r0+0
stx r0+1
lda drawbox_y2+0
ldx drawbox_y2+1
sta r1+0
stx r1+1
lda drawbox_x2+0
ldx drawbox_x2+1
sta r2+0
stx r2+1
lda drawbox_y2+0
ldx drawbox_y2+1
sta r3+0
stx r3+1
jsr fillbox ;Calls subroutine 'fillbox'
lda drawbox_x1+0
ldx drawbox_x1+1
sta r0+0
stx r0+1
lda drawbox_y1+0
ldx drawbox_y1+1
sta r1+0
stx r1+1
lda drawbox_x1+0
ldx drawbox_x1+1
sta r2+0
stx r2+1
lda drawbox_y2+0
ldx drawbox_y2+1
sta r3+0
stx r3+1
jsr fillbox ;Calls subroutine 'fillbox'
rts ;Return from subroutine
drawbox_x1 .word 0
drawbox_y1 .word 0
drawbox_x2 .word 0
drawbox_y2 .word 0
;** END :) **

ansiclrscr      jmp $e544
;--------------------------------------------------------------------------
;
;       PETIO.ASM
;       ---------
;
;      *** PETASCII I/O routines for Tapio language C-64 module ***
;       (C)1998 by Jari Tapio Tuominen, all rights reserved.
;
;--------------------------------------------------------------------------

;--------------------------------------------------------------------------
; Functions :
; (Name)                (Belongs to)            (ECPU registers)
;--------------------------------------------------------------------------
; ** Keyboard(/mouse), joystick and screen functions **
; putc11                System                  None
; print                 User                    r0=offset
; getch                 User                    r0=key pressed
; putch                 User                    r0=mark to output
; jgetchim              User                    r0=key pressed (0 if none)
; input                 User                    r0=Address to input store data
;                                                  (offset) f.e. "inputdata&"
;

; ** Disk functions **
; fopen                 User                    r0=handle r1=drive r2=?
;                                               r3=File name(offset)
; fload                 User                    r0=? r1=drive r2=?
;   \-> Uses $0330 kernal loader                r0=File name(offset)
; fdrive                User                    r0=Drive number(8-11)
; fclose                User                    r0=handle
; fioinit               User                    None
; fputc                 User                    r0=data
; fgetc                 User                    r0=handle, returns: r0=data
; fcreat                User                    r0=handle r1=drive r2=?
;                                               r3=File name(offset)
;
; Notice: All strings are (PC)ASCIIZ/(64)PETASCIIZ based,
;         so f.e. if you're planning to load some file in memory with fload,
;         then you should first produce an ASCIIZ or PETASCIIZ based string.
;
; (PET)ASCIIZ string example : "Hello world!",0
;
;--------------------------------------------------------------------------
putcbios rts
;--------------------------------------------------------------------------
putc11  jmp $ffd2
;--------------------------------------------------------------------------
;Prints asciiz string to stanard output
print   lda r0
        ldx r0+1
        sta $30
        stx $31
l000    ldy #0
        lda ($30),y
        cmp #0
        beq l002
        jsr putc11
        inc $30
        bne l001
        inc $31
l001    jmp l000
l002    rts
;--------------------------------------------------------------------------
getch   jsr $ffe4
        beq getch
        sta r0
        lda #0
        sta r0+1
        rts
;--------------------------------------------------------------------------
putch   lda r0
        jmp $ffd2
;--------------------------------------------------------------------------
jgetchim jsr $ffe4
        sta r0
        rts
;--------------------------------------------------------------------------
jgetfna stx $30       ;Hunts lenght of ASCIIZ based string and returns it
        sty $30+1
        ldy #0
jgetfl1 lda ($30),y
        cmp #0
        beq jgetfl2
        iny
        bne jgetfl1
jgetfl2 tya
        ldx $30
        ldy $30+1
        rts
;--------------------------------------------------------------------------
input   lda r0
        ldx r0+1
        sta $30
        stx $31
        ldy #0
inputl1 jsr $ffcf
        cmp #13
        beq inputl2
        sta ($30),y
        iny
        bne inputl1
inputl2 lda #0
        sta ($30),y
        sty $c8
        rts
;--------------------------------------------------------------------------
; *** Disk functions ***
;--------------------------------------------------------------------------
fopen   lda r0
        ldx r1
        ldy r2
        jsr $ffba
        ldx r3
        ldy r3+1
        jsr jgetfna
        jsr $ffc0
        ldx r0
        jmp $ffc6
;--------------------------------------------------------------------------
fload   lda #8
        ldx $ba
        tay
        jsr $ffba
        ldx r0
        ldy r0+1
        jsr jgetfna
        jmp $ffd5
;--------------------------------------------------------------------------
fdrive  lda r0
        sta $ba
        rts
;--------------------------------------------------------------------------
fclose  lda r0
        jmp $ffc3
;--------------------------------------------------------------------------
fioinit jmp $ffcc
;--------------------------------------------------------------------------
fputc   jmp $ffd2
;--------------------------------------------------------------------------
fgetc   lda r0
        jmp $f13e
;--------------------------------------------------------------------------
fcreat  nop
        lda r3
        ldx r3+1
        sta $30
        stx $31
        ldy #0
fcreatl lda ($30),y
        cmp #0
        beq fcreatz
        iny
        bne fcreatl
fcreatz lda #","
        sta ($30),y
        iny
        lda #"w"
        sta ($30),y
        iny
        lda #","
        sta ($30),y
        iny
        lda #"p"
        sta ($30),y
        iny
        lda #0
        sta ($30),y
        lda r0
        ldx r1
        ldy r2
        jsr $ffba
        ldx r3
        ldy r3+1
        jsr jgetfna
        jsr $ffc0
        ldx r0
        jmp $ffc9
;--------------------------------------------------------------------------

settype2                  ldx $c8
                 clc
                 adc #$41
                 sta $0200,x
                 inx
                 lda str_bmp
                 sta $0200,x
                 inx
                 lda str_bmp+1
                 sta $0200,x
                 inx
                 lda str_bmp+2
                 sta $0200,x
                 inx
                 lda str_bmp+3
                 sta $0200,x
rts ;Return from subroutine

str_bmp .text ".bmp"

settype1                  sta type_+0
                 stx type_+1
                 sty type_+2
                 ldx $c8
                 lda #"."
                 sta $0200,x
                 inx
                 lda type_
                 sta $0200,x
                 inx
                 lda type_+1
                 sta $0200,x
                 inx
                 lda type_+2
                 sta $0200,x
rts ;Return from subroutine
type_ .byte 0
.byte 0,0,0,0

load2                  lda #8
                 ldx $ba
                 tay
                 jsr $ffba
                 lda $c8
                 clc
                 adc #5
                 ldx #$00
                 ldy #$02
                 jsr $ffbd
                 lda #0
                 jsr $ffd5
rts ;Return from subroutine

load1_b                  lda #8
                 ldx $ba
                 tay
                 jsr $ffba
                 lda $c8
                 clc
                 adc #4
                 ldx #$00
                 ldy #$02
                 jsr $ffbd
                 lda #0 ; Verify = 0
                 jsr $ffd5
rts ;Return from subroutine

load1_c                  lda #8
                 ldx $ba
                 tay
                 jsr $ffba
                 lda $c8
                 clc
                 adc #4
                 ldx #$00
                 ldy #$02
                 jsr $ffbd
                 lda #0 ; Verify = 0
                 jsr $f4a5
rts ;Return from subroutine

str_mbc .text "mbc"

main lda #<$0200
ldx #>$0200
sta r0+0
stx r0+1
jsr input ;Calls subroutine 'input'
                 ;----
                 lda #0
                 sta $9d
                 ;--
                 lda str_mbc+0
                 ldx str_mbc+1
                 ldy str_mbc+2
                 jsr settype1
jsr load1_b ;Calls subroutine 'load1_b'
                 ;--
                 lda #"0"
                 ldx #"4"
                 ldy #"0"
                 jsr settype1
jsr load1_b ;Calls subroutine 'load1_b'
                 lda #$44
                 ldx #"8"
                 ldy #"0"
                 jsr settype1
jsr load1_c ;Calls subroutine 'load1_c'
                 ;--
                 lda #0
                 jsr settype2
                 ;
                 jsr load2
                 ;--
                 lda #1
                 jsr settype2
                 ;
                 jsr load2
jsr ibmpview ;Calls subroutine 'ibmpview'
lda #<$ff
 sta ibmpilace

ul                 jmp ul
;** END :) **
