;
;               VIC graphics library, 386 version.
;       (C)1998 by Jari Tapio Tuominen, all rights reserved.
;
; (Name)                (Belongs to)            (ECPU registers)
; graphmode             User                    None
; textmode              User                    None
; putpixel              User                    r0=x, r1=y and r2=color.
; waitsd                User                    Wait screen redraw

; Direct graphics mode
graphmode:      ;Set graphics mode
                mov ax,0x13
                int 10h
                ret

; Direct textmode
textmode:       ;Set text mode
                mov ax,0x03
                int 10h
                ret

; Direct put pixel.
putpixel:       ;r0,r1,r2 .. r0=x r1=y r2=color
                mov di,word [r1]
                mov ax,320
                imul di,ax
                add di,word [r0]
                mov ax,0xa000
                mov es,ax
                mov al,byte [r2]
                mov byte [es:di],al
                ret

; Wait for screean redraw.
waitsd:         mov dx,0x03da
                in  al,dx
                and al,8
                jz  waitsd
                ret

; Palette setting function. (8086 register based)
; AL=Red, AH=Green, BL=Blue, and cl=index.
setpalette1:
                push ax
                mov dx,0x03c8
                ; Out index
                mov al,cl
                out dx,al
                inc dx
                pop ax
                ; Out red
                out dx,al
                mov al,ah
                ; Out green
                out dx,al
                ; Out blue
                mov al,bl
                out dx,al
                ret

; Palette setting function (VCPU register based)
;
;       Usage: setpalette( index, red, green, blue );
;
setpalette:     mov cl,byte [r0]
                mov al,byte [r1]
                mov ah,byte [r2]
                mov bl,byte [r3]
                jmp setpalette1

; greyscale256
;
; Setups 256 greyscale palette. (Requires VGA graphics mode 0x13, or compatible)
;
greyscale256:   mov word [r0],0 ; Index
                mov word [r1],0 ; Red
                mov word [r2],0 ; Green
                mov word [r3],0 ; Blue
                mov word [r4],0 ; Decimal
greyscale256_l1:
                call setpalette

                inc word [r4]
                cmp word [r4],4
                jne greyscale256_l2
                mov word [r4],0
                inc word [r1]
                inc word [r2]
                inc word [r3]
greyscale256_l2:

                inc word [r0] ; Increase index value
                cmp word [r0],0
                jne greyscale256_l1
                ret
