;
;    HD Animation Player program (v1.0001)
;    ---------------------------        (C)1998 by Jari Tapio Tuominen,
;                                               all rights reserved.
;
;
;       Uses disk driver as input device!!(Might be slow)
;
;
;       Animation file description:
;
;               (Offset)
;               0x00            Start address(0x4000)
;               0x02            Background fillbyte (Usually,0x00 or 0xff)
;               0x03            Animation chunk
;
;       Codes:
;               0x53 = Seuraava kuva
;               0x54 = Warppi
;               0x56 = Monistus
;
;
                *=2061
caching1=       255
cache=          $4000
cachesiz=       $4000
playit          lda #0
                jsr print
                jsr inputfname
;                jmp skip
                ;
                lda #1
                jsr print
                ldx caching
                lda caching+1
                jsr $bdcd
                lda #2
                jsr print
                ldx #<cachesiz
                lda #>cachesiz
                jsr $bdcd
                lda #3
                jsr print
                ldx #<cache
                lda #>cache
                jsr $bdcd
skip            nop
                ;
                jsr waitkey
                ;
                nop
                jsr stimer
                lda #$36        ; Setup $a000-$c000 as RAM
                sta 1
                lda #$3b
                sta $d011
                lda #$19
                sta $d018
                lda #$d8
                sta $d016
                lda #0
                sta $d020
                sta $d021
                lda #$bc
                ldx #$0f
                jsr setcolors
                ;
again           lda #$49
                ldx #8
                ldy #0
                jsr $ffba
                lda $c8
                ldx #<$0200
                ldy #>$0200
                jsr $ffbd
                jsr $ffc0
                ldx #$49
                jsr $ffc6
                bit $90
                bvc gogogo
                jsr $ff81
                inc $d020
                inc $d021
                ldx #2
                jmp $e38b
gogogo          nop
                jsr readmore       ; SKIP START ADDRESS
                jsr readmore
                ;
                jsr constbmp
                jsr play
                jmp again
                ; Back to OS 8)
                rts

constbmp        lda #<$2000
                ldx #>$2000
                sta $34
                stx $35
                ldy #0
constbmpl1      lda $4000
                sta ($34),y
                iny
                lda $4000               ; REMOVE THIS IF YOU WANT BLANK LINES!
               ;lda #0
                sta ($34),y             ; 
                iny
                bne constbmpl1
                inc $35
                ldx $35
                cpx #$40
                bne constbmpl1
                rts

setcolors       sta 2
                stx 3
                ldy #0
setloop         lda 2
                sta $0400,y
                sta $0500,y
                sta $0600,y
                sta $0700,y
                sta $4400,y
                sta $4500,y
                sta $4600,y
                sta $4700,y
                lda 3
                sta $d800,y
                sta $d900,y
                sta $da00,y
                sta $db00,y
                iny
                bne setloop
                rts

play            nop
                ;
                lda #$00
                ldx #$20
                sta $40
                stx $41
                ;
                ;*Next frame*
loop1           lda $40
                ldx $41
                sta $32
                stx $33
                ;
                bit $90
                bvs thatsall
;                ldy #0
;                lda #$49
;                jsr readmore
;                cmp #$53
;                bne n53
;                lda #$49
;                jsr readmore           
;                cmp #$53
;                bne n53
;                jmp thatsall
n53             nop
                ;
                ; Start decoding to $2000
loop2           ldy #0
                jsr readmore
                cmp #$54
                bne n54                 ; WARPING!
                jsr readmore
                pha
                clc
                adc $32
                sta $32
                lda $33
                adc #0
                sta $33
                pla
                clc
                adc $32
                sta $32
                lda $33
                adc #0
                sta $33
                jmp loop2
                ; MONISTUS = 0x56
n54             cmp #$56
                bne n56
                jsr readmore
                sta 2       
                jsr readmore
                ldx #0
loop3           sta ($32),y                
                jsr i32
                sta ($32),y     ; Document this if you want blank lines!
                jsr i32
                inx
                cpx 2
                bne loop3
                jmp loop2
n56             cmp #$53
                beq looped1
                sta ($32),y
                iny             ; Document this if you want blank lines!
                sta ($32),y     ; -''-
                jsr i32
                jsr i32
                jmp loop2
looped1         lda #4
                lda #4
                jsr wait
                bit $90
                bvs thatsall
                jmp loop1
                ;
thatsall        lda #$49
                jsr $ffc3
                jsr $ffcc
                rts

i3e             inc $3e
                bne b3e
                inc $3f
b3e             rts

i38             inc $38
                bne b38
                inc $39
b38             rts

i3a             inc $3a
                bne b3a
                inc $3b
b3a             rts

i30             inc $30
                bne b30
                inc $31
b30             rts

i32             inc $32
                bne b32
                inc $33
b32             rts

filename        .text "anim"
                .byte 0

stimer          sei
                lda #<irq
                ldx #>irq
                sta $0314
                stx $0315
                lda #1
                sta $d01a
                sta $dc0d
                lda $d011
                and #$7f
                sta $d011
                lda #0
                sta $d012
                sta framer
                cli
                rts

irq             lda #255
                sta framer
                ;
                inc $d019
                jmp $ea31

wait            tax
waitl1          jsr wait1
                dex
                bne waitl1
                rts

wait1           lda #0
                sta framer
wait1l1         lda framer
                beq wait1l1
                rts

waitkey         lda #5
                jsr print
                jmp key

key             jsr $ffe4
                beq key
                sta k
                rts

k               .byte 0
framer          .byte 0
;----------------------------------------------------------------------------
inputfname      ldy #0
inputfnamel1    jsr $ffcf
                cmp #13
                beq inputfname13
                sta $0200,y
                iny
                bne inputfnamel1
inputfname13    sty $c8
                rts
;----------------------------------------------------------------------------
change          .byte 0
;----------------------------------------------------------------------------
cachechunk      lda #<cache
                ldx #>cache
                sta $38
                stx $39
                lda #0
                sta $3a
                sta $3b
                lda #2
                sta change
                ldy #0
l00             lda #$49
                jsr $ffcf
                sta ($38),y
                jsr i3a
                jsr i38
                cmp #$53
                bne ndetected53
                dec change
                beq ndetected53
ndetected53     ldx $39
                cpx #>(cache+cachesiz)
                bne l00
detected53      lda #<cache
                ldx #>cache
                sta $38
                stx $39
                rts
;----------------------------------------------------------------------------
readmore        bit caching
                bvs yes
                ;no
                lda #$49
                jmp $ffcf
                ;
yes             lda $3a
                bne ncachechunk
                lda $3b
                bne ncachechunk
                jsr cachechunk
ncachechunk     lda $3a
                sec
                sbc #1
                sta $3a
                lda $3b
                sbc #0
                sta $3b
                ldy #0
                lda ($38),y
                jsr i38
                rts
caching         .byte caching1 ; cache, 0=off, ff=on.
cached          .word 0
;----------------------------------------------------------------------------
t00             .byte 13
                .text "filename : "
                .byte 0
;----------------------------------------------------------------------------
t01             .byte 13
                .text "caching = "
                .byte 0
;----------------------------------------------------------------------------
t02             .byte 13
                .text "cache size = "
                .byte 0
;----------------------------------------------------------------------------
t03             .byte 13
                .text "cache location = "
                .byte 0
;----------------------------------------------------------------------------
t04             .byte 13
                .text "cache location = "
                .byte 0
;----------------------------------------------------------------------------
t05             .byte 13
                .text "press anykey to continue ..."
                .byte 0
;----------------------------------------------------------------------------

;----------------------------------------------------------------------------
tab             .word t00,t01,t02,t03,t04,t05
;----------------------------------------------------------------------------
print           asl
                tax
                lda tab,x
                sta $3e
                lda tab+1,x
                sta $3f
                ldy #0
printl1         lda ($3e),y
                cmp #0
                beq printz
                jsr $ffd2
                jsr i3e
                jmp printl1
printz          rts
;----------------------------------------------------------------------------
