;
;               VIC graphics library, 386 version.
;       (C)1998 by Jari Tapio Tuominen, all rights reserved.
;
; (Name)                (Belongs to)            (ECPU registers)
; graphmode             User                    None
; textmode              User                    None
; putpixel              User                    r0=x, r1=y and r2=color.
; waitsd                User                    Wait screen redraw

graphmode:      ;Set graphics mode
                mov ax,013h
                int 10h
                ret

textmode:       ;Set text mode
                mov ax,003h
                int 10h
                ret

putpixel:       ;r0,r1,r2 .. r0=x r1=y r2=color
                mov di,r1
                mov ax,320
                imul di,ax
                add di,r0
                mov ax,0a000h
                mov es,ax
                mov al,byte ptr r2
                mov byte ptr [es:di],al
                ret

waitsd:         mov dx,003dah
                in  al,dx
                and al,8
                jz  waitsd
                ret

; Palette setting function. (8086 register based)
; AL=Red, AH=Green, BL=Blue, and cl=index.
setpalette1:
                push ax
                mov dx,03c8h
                ; Out index
                mov al,cl
                out dx,al
                inc dx
                pop ax
                ; Out red
                out dx,al
                mov al,ah
                ; Out green
                out dx,al
                ; Out blue
                mov al,bl
                out dx,al
                ret

; Palette setting function (VCPU register based)
;
;       Usage: setpalette( index, red, green, blue );
;
setpalette:     mov cl,byte ptr r0
                mov al,byte ptr r1
                mov ah,byte ptr r2
                mov bl,byte ptr r3
                jmp setpalette1

; greyscale256
;
; Setups 256 greyscale palette. (Requires VGA graphics mode 0x13, or compatible)
;
greyscale256:   mov word ptr r0,0 ; Index
                mov word ptr r1,0 ; Red
                mov word ptr r2,0 ; Green
                mov word ptr r3,0 ; Blue
                mov word ptr r4,0 ; Decimal
greyscale256_l1:
                call setpalette

                inc word ptr r4
                cmp word ptr r4,4
                jne greyscale256_l2
                mov word ptr r4,0
                inc word ptr r1
                inc word ptr r2
                inc word ptr r3
greyscale256_l2:

                inc word ptr r0 ; Increase index value
                cmp word ptr r0,0
                jne greyscale256_l1
                ret

